
#include <inttypes.h>

#ifndef F_CPU
	#define F_CPU 8000000UL
#endif

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <string.h>

#include "lcd-text.h"
#include "ds1620.h"

int main()
{
	uint16_t hexTemperatur;
	float floatTemperatur;
	char *strTemperatur;
	uint8_t i;

	DDRD	=	0xff;
	DDRC	=	0x00;

	lcd_init();
	
	lcd_position(1, 1, LCD_E1);
	lcd_text("Temperatur: ", 12, LCD_E1);

	lcd_position(2, 1, LCD_E1);
	lcd_text("Hex-Code:   ", 12, LCD_E1);
	
	lcd_position(1, 1, LCD_E2);
	lcd_text("Config:     ", 12, LCD_E2);

	ds1620_init();
	ds1620_write_config(0x02); // Setzte CPU-Modus, kein 1SHOT
	ds1620_start();
	
	while(1)
	{
		// Zeit für die erste konvertierung geben.
		for(i = 0; i < 100; i++)
		{
			_delay_ms(10);
		}
		
		hexTemperatur = ds1620_read_temp();
		floatTemperatur = ds1620_convert_temp(hexTemperatur);

		sprintf(strTemperatur, "%6.2f",(double)floatTemperatur);
		lcd_position(1, 12, LCD_E1);
		lcd_text(strTemperatur, strlen(strTemperatur), LCD_E1);

		sprintf(strTemperatur, "%x",hexTemperatur);
		lcd_position(2, 12, LCD_E1);
		lcd_text(strTemperatur, strlen(strTemperatur), LCD_E1);
		
		sprintf(strTemperatur, "%x",ds1620_read_config());
		lcd_position(1, 12, LCD_E2);
		lcd_text(strTemperatur, strlen(strTemperatur), LCD_E2);
		
	}

	return 0;
}
